/******************************************************************************
 *	gpsubwin.c:	TuEBhE֌W̃W[
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <stdio.h>
#include <sxmemory.h>		/* }𗘗pƂɕKv	*/
#include <console.h>		/* R\[n}l[W𗘗pƂɕKv */
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <control.h>		/* Rg[}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "gpaint.h"		/* ̃vOŗL̃wb_t@C	*/

static	struct {			/* TuEBhE񃌃R[h	*/
	Rect winSize;			/* EBhETCY		*/
	Rect wtsize;			/* ^Cgo[TCY		*/
	Point loc;			/* N̐eEBhEɑ΂鑊Έʒu */
	unsigned long prio;		/* \Dx ( <<)		*/
} subinf[SUBMAX] = {
	{				/* J[IEBhE		*/
		{ 0, 0, 328, 73 },
		{ 0, 0, 328, WS_INSIDE_Y },
		{ 435, 5 }, 4
	}, {				/* pbgݒEBhE	*/
		{ 0, 0, 164, 123 },
		{ 0, 0, 164, WS_INSIDE_Y },
		{ 0, 256 }, 3
	}, {				/* c[IEBhE		*/
		{ 0, 0, 168, 97 },
		{ 0, 0, 168, WS_INSIDE_Y },
		{ 193, 300 }, 2
	}, {				/* [yEBhE		*/
		{ 0, 0, 403, 420 },
		{ 0, 0, 403, WS_INSIDE_Y },
		{ 361, 83 }, 1
	}
};

/******************************************************************************
 *	createSubwin():	TuEBhËi[Wj̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN createSubwin(ComVal *pcv)
{
	int i;
	Rect rc;

	for (i = 0; i < SUBMAX; i++) {
		/* [Wnh̎擾 */
		pcv->subRgnHdl[i] = GMNewRgn();
		if (pcv->subRgnHdl[i] == NULL)
			return FALSE;
		/* EBhE[W̐ݒ */
		rc = subinf[i].winSize;
		GMRectRgn(pcv->subRgnHdl[i], &rc);
		rc.d.top = rc.d.bottom - 1;
		rc.d.right = 4;
		GMXorRectRgn(pcv->subRgnHdl[i], pcv->subRgnHdl[i], &rc);
		rc.d.left = subinf[i].winSize.d.right - 1;
		rc.d.top = 0;
		rc.d.right = subinf[i].winSize.d.right;
		rc.d.bottom = 4;
		GMXorRectRgn(pcv->subRgnHdl[i], pcv->subRgnHdl[i], &rc);
		rc = (*pcv->subRgnHdl[i])->bounds;
		GMSlideRect(&rc, subinf[i].loc.x_y);
		/* EBhE\ʒu␳ */
		TSAdjustRect(&rc, &rc, 16);
		/* ␳̍WɂATuEBhẼ[Wړ */
		GMSlideRgn(pcv->subRgnHdl[i], rc.l.l_t);
	}
	/* TuEBhE̓J[IEBhEƃc[IEBhÊݕ\ */
	if (!openSubwin(pcv, 0))
		return FALSE;

	if (!openSubwin(pcv, 2))
		return FALSE;

	/* ̂TRUEԂ */
	return TRUE;
}

/******************************************************************************
 *	openSubwin():	TuEBhEI[v
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN openSubwin(ComVal *pcv, int num)
{
	/* STuEBhE쐬 */
	pcv->subwinPtr[num] = WSOpen(NULL, pcv->subRgnHdl[num], subinf[num].prio + 200);

	if (pcv->subwinPtr[num] == NULL)
		/* TuEBhE쐬łȂ̂ŏI */
		return FALSE;

	/* ^XNhc̏ʃ[hɃTuEBhE̒ʂԍ(OȊO) */
	pcv->subwinPtr[num]->win.taskID = LONGWORD(num + 1, TSGetID());
	if (!createSubControl(pcv, num))
		return FALSE;

	/* ̂TRUEԂ */
	return TRUE;
}

/******************************************************************************
 *	createSubControl():	TuEBhẼRg[̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN createSubControl(ComVal *pcv, int num)
{
	static Rect rcslvR = { 94, WS_INSIDE_Y + 6, 158, WS_INSIDE_Y + 22 };
	static Rect rcslvG = { 94, WS_INSIDE_Y + 30, 158, WS_INSIDE_Y + 46 };
	static Rect rcslvB = { 94, WS_INSIDE_Y + 54, 158, WS_INSIDE_Y + 70 };
	static Rect rcupdnR = { 16, WS_INSIDE_Y + 4, 90, WS_INSIDE_Y + 24 };
	static Rect rcupdnG = { 16, WS_INSIDE_Y + 28, 90, WS_INSIDE_Y + 48 };
	static Rect rcupdnB = { 16, WS_INSIDE_Y + 52, 90, WS_INSIDE_Y + 72 };
	static Rect rcbtnS = { 92, WS_INSIDE_Y + 76, 122, WS_INSIDE_Y + 95 };
	static Rect rcbtnA = { 130, WS_INSIDE_Y + 76, 160, WS_INSIDE_Y + 95 };

	static Rect rcslvX = { 62, WS_INSIDE_Y + 52, 102, WS_INSIDE_Y + 68 };
	static Rect rcslvY = { 122, WS_INSIDE_Y + 52, 162, WS_INSIDE_Y + 68 };

	/* eLXg^Cvɐݒ */
	GMSetGraph(&pcv->subwinPtr[num]->win.graph);
	GMAPage(G_PAGE0 | G_PAGE1);	/* ANZXy[WOƂPy[Wɂ */
	switch (num) {
	case 1:				/* pbgݒEBhE	*/
		/* XCh{[iqj쐬 */
		pcv->RGBSlvHdl[0] = CMOpen(&pcv->subwinPtr[PALET]->win,
			&rcslvR, NONTITLE, TRUE, 1, 0, 31, CI_SLDVOL << 4, 0);
		if (pcv->RGBSlvHdl[0] == NULL)
		/* XCh{[iqj쐬łȂ̂ŏI */
			return FALSE;

		/* XCh{[ifj쐬 */
		pcv->RGBSlvHdl[1] = CMOpen(&pcv->subwinPtr[PALET]->win,
			&rcslvG, NONTITLE, TRUE, 1, 0, 31, CI_SLDVOL << 4, 0);
		if (pcv->RGBSlvHdl[1] == NULL)
		/* XCh{[ifj쐬łȂ̂ŏI */
			return FALSE;

		/* XCh{[iaj쐬 */
		pcv->RGBSlvHdl[2] = CMOpen(&pcv->subwinPtr[PALET]->win,
			&rcslvB, NONTITLE, TRUE, 1, 0, 31, CI_SLDVOL << 4, 0);
		if (pcv->RGBSlvHdl[2] == NULL)
		/* XCh{[iaj쐬łȂ̂ŏI */
			return FALSE;

		/* l{^iqj쐬 */
		pcv->RGBBtnHdl[0] = CMOpen(&pcv->subwinPtr[PALET]->win,
			&rcupdnR, NONTITLE, TRUE, 1, 0, 31, CI_ADJBTN << 4, 0);
		if (pcv->RGBBtnHdl[0] == NULL)
		/* l{^iqj쐬łȂ̂ŏI */
			return FALSE;

		/* l{^ifj쐬 */
		pcv->RGBBtnHdl[1] = CMOpen(&pcv->subwinPtr[PALET]->win,
			&rcupdnG, NONTITLE, TRUE, 1, 0, 31, CI_ADJBTN << 4, 0);
		if (pcv->RGBBtnHdl[1] == NULL)
		/* l{^ifj쐬łȂ̂ŏI */
			return FALSE;

		/* l{^iaj쐬 */
		pcv->RGBBtnHdl[2] = CMOpen(&pcv->subwinPtr[PALET]->win,
			&rcupdnB, NONTITLE, TRUE, 1, 0, 31, CI_ADJBTN << 4, 0);
		if (pcv->RGBBtnHdl[2] == NULL)
		/* l{^쐬łȂ̂ŏI */
			return FALSE;

		/* [ݒ]{^쐬 */
		pcv->setBtnHdl = CMOpen(&pcv->subwinPtr[PALET]->win, &rcbtnS,
			(_LASCII)"\x04ݒ", TRUE, 1, 0, 1, CI_CHRBTN << 4, 0);
		if (pcv->setBtnHdl == NULL)
		/* [ݒ]{^쐬łȂ̂ŏI */
			return FALSE;

		/* []{^쐬 */
		pcv->canBtnHdl = CMOpen(&pcv->subwinPtr[PALET]->win, &rcbtnA,
			(_LASCII)"\x04", TRUE, 1, 0, 1, CI_CHRBTN << 4, 0);
		if (pcv->canBtnHdl == NULL)
		/* []{^쐬łȂ̂ŏI */
			return FALSE;

		/* {^i[ݒ]^[]jgpstOIȂ */
		if (pcv->disableBtn) {
			/* {^CANeBuɂ */
			CMShine(pcv->setBtnHdl, C_INACTIVE);
			CMShine(pcv->canBtnHdl, C_INACTIVE);
		}
		break;
	case 2:				/* c[IEBhE		*/
		/* XCh{[쐬 */
		pcv->slvHHdl = CMOpen(&pcv->subwinPtr[TOOL]->win, &rcslvX,
			NONTITLE, TRUE, 1, 1, 16, CI_SLDVOL << 4, 0);
		if (pcv->slvHHdl == NULL)
		/* XCh{[쐬łȂ̂ŏI */
			return FALSE;

		pcv->slvVHdl = CMOpen(&pcv->subwinPtr[TOOL]->win, &rcslvY,
			NONTITLE, TRUE, 1, 1, 16, CI_SLDVOL << 4, 0);
		if (pcv->slvVHdl == NULL)
		/* XCh{[쐬łȂ̂ŏI */
			return FALSE;
		break;
	}

	return TRUE;
}

/******************************************************************************
 *	msLDownSubwin(): TuEBhẼ}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍiO`Rj
 *	:
 *	TuEBhEŃ}EX̍{^ꂽꍇ̏sB
 *	̏ŃN[Y{^ɂATuEBhËړ\ƂȂ܂B
 */
void msLDownSubwin(ComVal *pcv, int num)
{
	LPoint lpt, lpos;
	Rect rc = { 0, 0, WS_CLOSE_W, WS_CLOSE_W };

	/* TuEBhEeLXg^CvŃJgOtɂ */
	setGraph(&pcv->subwinPtr[num]->win, G_TXT);

	/* ݂̍̍Wlۑ */
	lpos = (*pcv->subRgnHdl[num])->bounds.l.l_t;
	/* ͍W[JWnɕϊ */
	lpt = GMGlobalToLocal(pcv->event.ev.where.x_y);
	/* N[Y{^̈ʒuZo */
	GMSlideRect(&rc, LONGWORD(subinf[num].wtsize.d.right - 14, 4));
	/* N[Y{^`FbN */
	if (GMPtInRect(&rc, lpt)) {
		if (checkPctBtn(pcv, &rc, lpt, 1)) {
			if (num == 3) {
				/* [yEBhẼN[YȂ */
				if (pcv->subwinPtr[TOOL] != NULL)
					/* c[̑IԍύX郋[y
					   IȌԂɖ߂ */
					changeTool(pcv, pcv->lupeTool);
				else {
					pcv->toolKind = pcv->lupeTool;
					/* gGȀ */
					dispLupeRect(pcv);
					/* TuEBhȄ */
					disposeSubwin(pcv, num);
				}
			} else
				/* TuEBhȄ */
				disposeSubwin(pcv, num);
		}
	} else if (GMPtInRect(&subinf[num].wtsize, lpt)) {
		/* ꂽ^Cgo[łΈȉ̏ */
		if (!dragSubwin(pcv, &subinf[num].winSize, lpos, lpt, num)) {
			/* TuEBhE쐬łȂ̂ŏI */
			pcv->errorCode = 5; /* hbOłȂ	*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
		}
	} else {
		/*ꂽʒu^Cgo[łȂ*/
		switch (num) {
		case 0:			/* J[IEBhE		*/
			colorMsLDown(pcv);
			break;
		case 1:			/* pbgݒEBhE	*/
			paletMsLDown(pcv);
			break;
		case 2:			/* c[IEBhE		*/
			toolMsLDown(pcv);
			break;
		case 3:			/* [yEBhE		*/
			lupeMsLDown(pcv);
			break;
		}
	}
}

/******************************************************************************
 *	checkPctBtn():	sN`[{^̃`FbN
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		Rect *prc	sN`[{^̃N^Oւ̃|C^
 *		LPoint lpt	|C^W([JWnj
 *	߂l:	BOOLEAN		= TRUE:  {^ꂽ
 *				= FALSE: {^͉ĂȂ
 */
BOOLEAN checkPctBtn(ComVal *pcv, Rect *prc, LPoint lpt, int mode)
{
	BOOLEAN ret = TRUE;

	if (!GMPtInRect(prc, lpt))
		return FALSE;

	if (mode == 1)
		revFillRect(prc);
	else
		revFrameRect(prc);
	/* }EX{^܂Ń[v */
	while (EMLStill()) {
		lpt = EMMSLoc();
		if (GMPtInRect(prc, lpt)) {
			/* {^ɃJ[\ړ */
			if (!ret) {
			/* {^ĂȂ΃t[𔽓] */
				if (mode == 1)
					revFillRect(prc);
				else
					revFrameRect(prc);
				ret = TRUE;
			}
		} else {
			/* {^OɃJ[\ړ */
			if (ret) {
			/* {^ĂȂt[𔽓] */
				if (mode == 1)
					revFillRect(prc);
				else
					revFrameRect(prc);
				ret = FALSE;
			}
		}
	}
	/* }EX{^ꂽꍇ̏ */
	if (ret) {
		/* {^Ă΃t[߂ */
		if (mode == 1)
			revFillRect(prc);
		else
			revFrameRect(prc);
	}
	/* {^ꂽꏊ`FbN */
	if (!GMPtInRect(prc, lpt))
		return FALSE;

	return ret;
}

/******************************************************************************
 *	revFillRect():	N^OŜ̔]
 ******************************************************************************
 *	:	Rect *prc	]郌N^Oւ̃|C^
 */
void revFillRect(Rect *prc)
{
	int lastAP, lastFC, lastPM;

	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastPM = GMPenMode(G_XOR);	/* y[hXORɂ	*/
	lastFC = GMForeColor(G_BLACK);

	GMFillRect(prc);

	GMForeColor(lastFC);
	GMPenMode(lastPM);
	GMAPage(lastAP);
}

/******************************************************************************
 *	revFrameRect():	N^Õt[𔽓]
 ******************************************************************************
 *	:	Rect *prc	]郌N^Oւ̃|C^
 */
void revFrameRect(Rect *prc)
{
	int lastAP, lastFC, lastPM;

	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastPM = GMPenMode(G_XOR);	/* y[hXORɂ	*/
	lastFC = GMForeColor(G_BLACK);

	GMFrameRect(prc);

	GMForeColor(lastFC);
	GMPenMode(lastPM);
	GMAPage(lastAP);
}

/******************************************************************************
 *	dragSubwin():	TuEBhE}EXœꂽƂ̏
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		Rect *prc	TuEBhẼN^Oւ̃|C^
 *		LPoint lpos	ꂽƂ̍̍W
 *		LPoint lpt	ꂽƂ̃|C^W
 *		int num		TuEBhE̔ԍ
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: ُ
 */
BOOLEAN dragSubwin(ComVal *pcv, Rect *prc, LPoint lpos, LPoint lpt, int num)
{
	Point pt, npt, dpt, pt2;
	Rect rc;

	/* [ẙg͈͂̈ړ֎~tOI*/
	if (pcv->subwinPtr[LUPE] != NULL)
		pcv->moveLock = TRUE;

	/* _Ńo[oh\ */
	/* TuEBhEeLXg^CvŃJgOtɂ */
	setGraph(&pcv->subwinPtr[num]->win, G_TXT);
	GMAPage(G_PAGE0 | G_PAGE1);	/* ANZXy[WOƂPy[Wɂ */
	OldFC = GMForeColor(G_BLACK);
	OldBC = GMBackColor(G_LGRAY);
	GMInvertRect(prc, WS_RUBBERBAND);

	/* TuEBhE̍W}EX݈̌ʒu܂ł̋Zo */
	pt2.p.x = pcv->event.ev.where.p.x - (*pcv->subRgnHdl[num])->bounds.d.left;
	pt2.p.y = pcv->event.ev.where.p.y - (*pcv->subRgnHdl[num])->bounds.d.top;
	rc = *prc;
	pt.x_y = lpt;
	/* {^ꂽ܂܂ɂȂĂΓ_̃o[ohړĕ\ */
	while (EMLStill()) {
		/* }EX݈̌ʒu擾 */
		npt.x_y = EMMSLoc();
		/* }EXړꂽꍇ̂݃o[oḧړ */
		if (pt.x_y != npt.x_y) {
			/* o[oh */
			GMInvertRect(&rc, WS_RUBBERBAND);
			/* VȃN^O̎Zo */
			dpt.p.x = npt.p.x - pt.p.x;
			dpt.p.y = npt.p.y - pt.p.y;
			GMSlideRect(&rc, dpt.x_y);
			/* _Ńo[oh` */
			GMInvertRect(&rc, WS_RUBBERBAND);
		}
		pt = npt;
	}
	/* ꂽI (o[oh) */
	GMInvertRect(&rc, WS_RUBBERBAND);
	/* TuEBhE̍W߂ */
	pt.p.x -= pt2.p.x;
	pt.p.y -= pt2.p.y;
	/* V[W̃Zbg */
	GMSlideRgn(pcv->subRgnHdl[num], pt.x_y);
	/* tHA^obNOEhJ[ɖ߂ */
	GMForeColor(OldFC);
	GMBackColor(OldBC);
	/* V[WZbg */
	GMSlideRect(&rc, lpos);
	(*pcv->subRgnHdl[num])->bounds = rc;

	/* TuEBhE̔p */
	disposeSubwin(pcv, num);

	/* TuEBhEI[v */
	if (!openSubwin(pcv, num))
		return FALSE;

	/* [ẙg͈͂̈ړ֎~tOIt*/
	if (pcv->subwinPtr[LUPE] != NULL)
		pcv->moveLock = FALSE;

	return TRUE;
}

/******************************************************************************
 *	drawSubwin():	TuEBhE̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 */
void drawSubwin(ComVal *pcv, int num)
{
	int lastPM, lastFC, lastBC;
	Rect rc;

	/* TuEBhEeLXg^CvŃJgOtɂ */
	setGraph(&pcv->subwinPtr[num]->win, G_TXT);

	/* [yEBhEȊOȂtHAOEhJ[CgO[ɂ
	   TuEBhEŜhԂB[yEBhEȂ^Cgo[
	   ̂ݓhԂAɃ^[go[ȊO͓̕ɂ */
	lastPM = GMPenMode(G_PSET);
	lastFC = GMForeColor(G_LGRAY);	/* tHAOEhJ[̃Zbg */
	lastBC = GMForeColor(G_LGRAY);	/* obNOEhJ[̃Zbg */
	/* [yEBhEȊO */
	if (num != 3)
		/* TuEBhEhԂ */
		GMFillRect(&subinf[num].winSize);
	else
		/* TuEBhEhԂ */
		GMFillRect(&subinf[3].wtsize);
	/* TuEBhE̊Ogŕ` */
	GMForeColor(G_BLACK);		/* tHAOEhJ[̃Zbg */
	rc = subinf[num].winSize;
	rc.d.right -= 1;
	rc.d.bottom -= 1;
	GMFrameRect(&subinf[num].winSize);
	GMFrameRect(&rc);

	drawSubTitleBar(pcv,num);

	/* tHA^obNOEhJ[A[hɖ߂ */
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMPenMode(lastPM);
}

/******************************************************************************
 *	drawSubTitleBar():	TuEBhẼ^Cg̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhEԍ
 */
void drawSubTitleBar(ComVal *pcv, int num)
{
	int lastAP;
	Rect rc;

	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	GMForeColor(G_DGRAY);
	rc.l.l_t = LONGWORD(1, 1);
	rc.l.r_b = LONGWORD(subinf[num].wtsize.d.right - 2, 17);
	GMFillRect(&rc);
	GMForeColor(G_WHITE);
	rc.l.r_b = LONGWORD(3, 16);
	GMFillRect(&rc);
	rc.l.l_t = LONGWORD(3, 1);
	rc.l.r_b = LONGWORD(subinf[num].wtsize.d.right - 2, 3);
	GMFillRect(&rc);
	GMForeColor(G_DGRAY);
	rc.l.l_t = LONGWORD(2, 15);
	rc.d.bottom = 18;
	GMFillRect(&rc);
	GMForeColor(G_BLACK);
	rc.l.l_t = LONGWORD(subinf[num].wtsize.d.right - 3, 2);
	rc.d.right++;
	rc.d.bottom--;
	GMFillRect(&rc);
	rc.l.l_t = LONGWORD(1, 16);
	rc.d.right -= 2;
	GMFillRect(&rc);
	rc.l.l_t = LONGWORD(3, 15);
	rc.d.bottom--;
	GMFillRect(&rc);

	/* N[Y{^̕` */
	GMPutRImg(*pcv->tlBtnImg[16], LONGWORD(subinf[num].wtsize.d.right - 14, 4));
	GMAPage(lastAP);
}

/******************************************************************************
 *	dispSubwin():	ׂẴTuEBhE\^\ɂ
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		BOOLEAN dsp	\^\tO
 *				= TRUE:  \
 *				= FALSE: \
 */
void dispSubwin(ComVal *pcv, BOOLEAN dsp)
{
	int i;

	for (i = 0; i < SUBMAX; i++)
		if (pcv->subwinPtr[i] != NULL) {
			if (dsp)
				/* \vȂATuEBhE\ */
				WSEnlist(pcv->subwinPtr[i]);
			else
				/* \vȂATuEBhE\ɂ */
				WSDelist(pcv->subwinPtr[i]);
		}
}

/******************************************************************************
 *	disposeSubwin():	TuEBhEp
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 */
void disposeSubwin(ComVal *pcv, int num)
{
	switch (num) {
	case 1:				/* pbgݒEBhE	*/
	case 2:				/* c[IEBhE		*/
		CMKill(&pcv->subwinPtr[num]->win); /* Rg[p */
		break;
	case 3:				/* [yEBhE		*/
		pcv->moveLock = TRUE;	/*g͈͂̈ړ֎~tOI */
		break;
	}
	/* TuEBhE̔p */
	WSDispose(pcv->subwinPtr[num]);

	/* |C^NA */
	pcv->subwinPtr[num] = NULL;
}
